addpath('poblano_toolbox');

nnpts = 5;
pptx=zeros(nnpts,1);
pptg_thomson=zeros(nnpts,1);
pptlax_thomson=zeros(nnpts,1);
pptg_graph=zeros(nnpts,1);
pptlax_graph=zeros(nnpts,1);

load('newAdHealth');
G = sparse(graphsNoSelfLoop{9});

for i=1:nnpts
    pptx(i)=2^i;
    npts = pptx(i);

    %% Checking gradient of thompson problem

    dim = 3;
    n = npts * dim;
    m = npts;

    x0 = rand(n,1);

    thomson_check=gradientcheck(@(x) thomson(x,n,m),x0, 'DifferenceType', 'centered', 'DifferenceStep', 10^(i-9));
    y = zeros(m,1);
    rhok = 100;
    thomson_lax_check = gradientcheck(@(xx) flax(xx, @(x) thomson(x,n,m), @(x) thomson_c(x,n,m), y, rhok), x0, 'DifferenceType', 'centered', 'DifferenceStep', 10^(i-9));


    %% Checking gradient of graph embedding problem
    GG=snowball(G,npts);
    L = diag(GG*ones(npts,1))-GG;
    
    dim = 3;
    n = npts * dim;
    m = dim+npts;

    x0 = rand(n,1);

    graph_check=gradientcheck(@(x) graph(x,npts,dim,L),x0, 'DifferenceType', 'centered', 'DifferenceStep', 10^(i-9));
    y = zeros(m,1);
    rhok = 100;
    graph_lax_check = gradientcheck(@(xx) flax(xx, @(x) graph(x,npts,dim,L), @(x) graph_c(x,npts,dim), y, rhok), x0, 'DifferenceType', 'centered', 'DifferenceStep', 10^(i-9));

    %% Collect result
    pptg_thomson(i) = thomson_check.NormGradientDiffs;
    pptlax_thomson(i) = thomson_lax_check.NormGradientDiffs;
    pptg_graph(i) = graph_check.NormGradientDiffs;
    pptlax_graph(i) = graph_lax_check.NormGradientDiffs;
    
end

dlmwrite('../../progress/script/cg_thomson.txt', [pptx,pptg_thomson],' ');
dlmwrite('../../progress/script/cglax_thomson.txt', [pptx,pptlax_thomson],' ');
dlmwrite('../../progress/script/cg_graph.txt', [pptx,pptg_graph], ' ');
dlmwrite('../../progress/script/cglax_graph.txt', [pptx,pptlax_graph], ' ');

