function [f,g] = thomson(x,n,m,varargin)

dim = n/m;

f=0;

xnormsq = zeros(m*(m-1)/2,1);
xdiffs = zeros(m*(m-1)/2,dim);

index = 1;

for i=1:m-1,
    for j=i+1:m,
        xi = x((i-1)*dim+1:i*dim);
        xj = x((j-1)*dim+1:j*dim);
        xdiffs(index,:) = (xj-xi)';
        xnormsq(index) = (xdiffs(index,:)*xdiffs(index,:)');
        f = f + 1.0/xnormsq(index);
        index = index + 1;
    end
end

if nargout > 1
    g = zeros(n,1);
    for i=1:m,
        for j=1:m,
            if (j > i)
                index = m*(i-1)-(i)*(i-1)/2+j-i;
                g((i-1)*dim+1:i*dim) = g((i-1)*dim+1:i*dim) + 2 * xdiffs(index,:)' ./(xnormsq(index)^2);
                
            elseif (j < i)
                index = m*(j-1)-(j)*(j-1)/2+i-j;
                g((i-1)*dim+1:i*dim) = g((i-1)*dim+1:i*dim) + 2 * -xdiffs(index,:)' ./(xnormsq(index)^2);                
            end
        end
    end
end
    
end

